unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, TeeProcs, TeeComma, TeEngine;

type
  TForm1 = class(TForm)
    TeeCommander1: TTeeCommander;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure Chart1BeforeDrawSeries(Sender: TObject);
    function Point1OnGetPointerStyle(Sender:TChartSeries; ValueIndex:Integer):TSeriesPointerStyle;
    procedure Point1OnGetMarkText(Sender:TChartSeries; ValueIndex:Integer; var MarkText:String);
  public
    { Public declarations }
  end;

  TAbsorbedList = class(TList)
    function GetItem(Index:Integer):Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Chart, Series, TeCanvas, Types;

var Chart1: TChart;
    Point1: TPointSeries;

    VisiblePnts: array of Boolean;
    AbsorvingPnts: array of Boolean;
    Point1HorizSize, Point1VertSize, Point1AbsHorizSize, Point1AbsVertSize: Integer;
    Point1Color, Point1AbsColor: TColor;
    AbsorbedItems: array of TAbsorbedList;

procedure TForm1.FormCreate(Sender: TObject);

  procedure AddPointsNextTo(index: Integer);
  var tmpX, tmpY: Double;
      i: Integer;
  begin
    with Point1 do
    begin
      tmpX:=XValue[index];
      tmpY:=YValue[index];

      for i:=0 to 4 do
        Point1.AddXY(tmpX+random-0.5, tmpY+random-0.5);
    end;
  end;

begin
  Chart1:=TChart.Create(Self);
  Chart1.Parent:=Self;
  Chart1.Align:=alClient;

  TeeCommander1.Panel:=Chart1;

  Chart1.View3D:=false;
  Chart1.Legend.Visible:=false;
  Chart1.Hover.Visible:=false;

  Point1:=Chart1.AddSeries(TPointSeries) as TPointSeries;
  Point1.FillSampleValues(10);

  AddPointsNextTo(2);
  AddPointsNextTo(12);

  Point1HorizSize:=Point1.Pointer.HorizSize;
  Point1VertSize:=Point1.Pointer.VertSize;
  Point1AbsHorizSize:=Point1.Pointer.HorizSize*2;
  Point1AbsVertSize:=Point1.Pointer.VertSize*2;
  Point1Color:=Point1.Color;
  Point1AbsColor:=clYellow;
  Point1.Marks.Visible:=true;

  Chart1.OnBeforeDrawSeries:=Chart1BeforeDrawSeries;
  Point1.OnGetPointerStyle:=Point1OnGetPointerStyle;
  Point1.OnGetMarkText:=Point1OnGetMarkText;
end;

procedure TForm1.Chart1BeforeDrawSeries(Sender: TObject);

  procedure findReAbsorbed(byIndex, toIndex: Integer);
  var i: Integer;
      tmpX, tmpY: Integer;
      tmpRect1, tmpRect2, dummyRect: TRect;
      pIndex: ^Integer;
  begin
    tmpX:=Point1.CalcXPos(byIndex);
    tmpY:=Point1.CalcYPos(byIndex);

    tmpRect1:=Rect(tmpX-Point1AbsHorizSize, tmpY-Point1AbsVertSize,
                   tmpX+Point1AbsHorizSize, tmpY+Point1AbsVertSize);

    for i:=0 to toIndex do
    begin
      if byIndex<>i then
      begin
        tmpX:=Point1.CalcXPos(i);
        tmpY:=Point1.CalcYPos(i);

        if AbsorvingPnts[i] then
          tmpRect2:=Rect(tmpX-Point1AbsHorizSize, tmpY-Point1AbsVertSize,
                         tmpX+Point1AbsHorizSize, tmpY+Point1AbsVertSize)
        else
          tmpRect2:=Rect(tmpX-Point1HorizSize, tmpY-Point1VertSize,
                       tmpX+Point1HorizSize, tmpY+Point1VertSize);

        if (IntersectRect(dummyRect, tmpRect1, tmpRect2)) and VisiblePnts[i] then
        begin
          VisiblePnts[i]:=false;
          new(pIndex);
          pIndex^:=i;
          AbsorbedItems[byIndex].Add(pIndex);
        end;
      end;
    end;
  end;

var i, j: Integer;
    tmpX, tmpY: Integer;
    tmpRect1, tmpRect2, dummyRect: TRect;
    pIndex: ^Integer;
begin
  SetLength(VisiblePnts, Point1.Count);
  SetLength(AbsorvingPnts, Point1.Count);
  SetLength(AbsorbedItems, Point1.Count);

  for i:=0 to Point1.Count-1 do
  begin
    VisiblePnts[i]:=true;
    AbsorvingPnts[i]:=false;
    Point1.ValueColor[i]:=Point1Color;
    AbsorbedItems[i]:=TAbsorbedList.Create;
  end;

  for i:=0 to Point1.Count-1 do
  begin
    tmpX:=Point1.CalcXPos(i);
    tmpY:=Point1.CalcYPos(i);

    tmpRect1:=Rect(tmpX-Point1HorizSize, tmpY-Point1VertSize,
                   tmpX+Point1HorizSize, tmpY+Point1VertSize);

    if (IntersectRect(dummyRect, tmpRect1, Chart1.ChartRect)) and VisiblePnts[i] then
      for j:=0 to Point1.Count-1 do
      begin
        if i<>j then
        begin
          tmpX:=Point1.CalcXPos(j);
          tmpY:=Point1.CalcYPos(j);
          tmpRect2:=Rect(tmpX-Point1HorizSize, tmpY-Point1VertSize,
                         tmpX+Point1HorizSize, tmpY+Point1VertSize);

          if VisiblePnts[j] and (IntersectRect(dummyRect, tmpRect1, tmpRect2)) then
          begin
            AbsorvingPnts[i]:=true;
            Point1.ValueColor[i]:=Point1AbsColor;
            VisiblePnts[j]:=false;
            new(pIndex);
            pIndex^:=j;
            AbsorbedItems[i].Add(pIndex);

            tmpRect1:=Rect(tmpX-Point1AbsHorizSize, tmpY-Point1AbsVertSize,
                           tmpX+Point1AbsHorizSize, tmpY+Point1AbsVertSize);

            findReAbsorbed(i, j-1);
          end;
        end;
      end;
    end;
end;

function TForm1.Point1OnGetPointerStyle(Sender:TChartSeries; ValueIndex:Integer):TSeriesPointerStyle;
begin
  result:=Point1.Pointer.Style;

  if ValueIndex>-1 then
  begin
    if (not VisiblePnts[ValueIndex]) then
      result:=psNothing;

    if AbsorvingPnts[ValueIndex] then
    begin
      Point1.Pointer.HorizSize:=Point1AbsHorizSize;
      Point1.Pointer.VertSize:=Point1AbsVertSize;
    end
    else
    begin
      Point1.Pointer.HorizSize:=Point1HorizSize;
      Point1.Pointer.VertSize:=Point1VertSize;
    end;
  end;
end;

procedure TForm1.Point1OnGetMarkText(Sender:TChartSeries; ValueIndex:Integer; var MarkText:String);
var i, tmp: Integer;
    pIndex: ^Integer;
begin
  if ValueIndex>-1 then
  begin
    if not VisiblePnts[ValueIndex] then
      MarkText:='';

    if AbsorvingPnts[ValueIndex] then
      for i:=0 to AbsorbedItems[ValueIndex].Count-1 do
      begin
        pIndex:=AbsorbedItems[ValueIndex].Get(i);
        tmp:=pIndex^;
        MarkText:=MarkText+sLineBreak+FormatFloat(Point1.ValueFormat, Point1.YValue[tmp]);
      end;
  end;
end;

function TAbsorbedList.GetItem(Index:Integer):Integer;
begin
  result:=Integer(inherited Items[Index]);
end;

end.
